/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package loan;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.xml.ws.WebServiceRef;
import tiresias.TiresiasService;

/**
 *
 * @author Myron
 */
@WebService()
public class LoanWS {
    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/client/TiresiasService/localhost_8080/Tiresias/TiresiasService.wsdl")
    private TiresiasService service;

    /**
     * Web service operation
     */
    @WebMethod(operationName = "processLoanApplication")
    public String processLoanApplication(@WebParam(name = "name")
    String name, @WebParam(name = "address")
    String address, @WebParam(name = "age")
    int age, @WebParam(name = "annualSalary")
    double annualSalary, @WebParam(name = "amountRequested")
    double amountRequested) {
        // XML Whether on black list or not???


        try { // Call Web Service Operation
            tiresias.Tiresias port = service.getTiresiasPort();
            boolean result = port.isBlackListed(name);
            if(result)
                return "Your loan has been rejected, since you are already in the black list";
        } catch (Exception ex) {
            System.exit(0);
        }

        ///private method
        // call for the black list
        
        //TODO write your implementation code here:
        int MINIMUM_AGE_LIMIT = 18;
		int MAXIMUM_AGE_LIMIT = 65;
		double MINIMUM_SALARY = 20000;
		int AVERAGE_LIFE_EXPECTANCY = 70;
		String result = "Loan Application APPROVED.";

		// Check age of applicant
		// If less than min age limit, rejected
		if(age < MINIMUM_AGE_LIMIT) {
			result = "Loan Application REJECTED - Reason: Under-aged " +
			age + ". Age needs to be over " +MINIMUM_AGE_LIMIT +" years to qualify.";
			
			return result;
		}

		// Check age of applicant
		// If more than max age limit, rejected
		if(age > MAXIMUM_AGE_LIMIT) {
			result = "Loan Application REJECTED - Reason: Over-aged " +
			age +". Age needs to be under " +MAXIMUM_AGE_LIMIT +	" years to qualify.";
			
			return result;
		}

		// Check annual salary
		// If less than min salary, rejected
		if(annualSalary < MINIMUM_SALARY) {
			result = "Loan Application REJECTED - Reason: Annual Salary $" +
			annualSalary +
			" too low. Annual Salary needs to be over $" +
			MINIMUM_SALARY +
			" to qualify.";
			
			return result;
		}

		// Calculate the years to pay off loan based on applicantAge
		int yearsToRepay = AVERAGE_LIFE_EXPECTANCY - age;

		// Calculate the max amount of loan based on years to pay off loan
		double limit = annualSalary * yearsToRepay * 0.5;

		// Check amount requested, if higher than limit, rejected
		if(amountRequested > limit) {
			result = "Loan Application REJECTED - Reason: You are asking for too much $" +
			amountRequested +". Annual Salary $" +
			annualSalary +", Age " +age +" years. Your limit is $" +limit;			
			return result;
		}
		return result;
    }

}
